program solvalla;

uses dos,crt;

type namn=array [1..56] of string;

var xpo,i,j,vi,lp,max: byte;
    h,kr: longint;
    co: integer;
    cz: char;
    kuse: namn;
    sg,goal: string;
    x,ox: array [1..8] of byte;
    v,hodds: array [1..8] of real;
    hnamn: array [1..8] of string [16];
    knum: array [1..56] of boolean;
    hnum: array [0..8] of boolean;

procedure read_horse;
  var f: text;
  begin
    assign (f,'solvalla.dat');
    reset (f);
    for i:=1 to 56 do readln (f,kuse[i]);
    close (f);
  end;


procedure Curs(d:boolean);
  var regs : registers;
  begin
    with regs do
      begin
        ah:=1;
        if d=true then ch:=37 else ch:=5;
        cl:=6;
        intr($10,regs);
      end;
  end;

procedure winit (x1,y1,x2,y2,bk,tx: byte);
  begin
    window (x1,y1,x2,y2);
    textbackground (bk);
    textcolor (tx);
    clrscr;
  end;

procedure tang;
  begin
    Curs(true);
    cz:=readkey;
    Curs(false);
    clrscr;
    if cz=#27 then halt;
  end;

procedure valk;
  begin
    winit (1,1,80,25,0,15);
    gotoxy (28,1);
    writeln ('Vlkommen till Solvalla!');
    gotoxy (1,3);
    writeln ('Du ska f satsa ett kapital av 1000 kr p sju travlopp.');
    writeln ('Genom att ta hnsyn till hstarnas odds, och delvis deras startposition');
    writeln ('(en hst ytterst ser lttare om det r en hst framfr n en hst innerst),');
    writeln ('ska du frska att efter dagens lopp ha mer n de 1000 kr du startade med.');
    gotoxy (1,8);
    writeln ('Du fr 500 kr i bonus om du har fem rtt av sju, 750 kr om du har sex rtt');
    writeln ('och hela 1000 kr om alla sju hstarna r rtt! Men om du fr slut p pengar');
    writeln ('innan alla sju loppen r avklarade, r dagen slut fr din del!');
    gotoxy (1,12);
    writeln ('OBS: Du kan aldrig satsa p mer n tre hstar per lopp (det r tta i varje),');
    writeln ('     och du kan aldrig satsa mer n halva ditt kapital p en enskild hst!!!');
    gotoxy (1,15);
    writeln ('Du fr bara utdelning fr vinnande hst. Spel p placering frekommer inte hr!');
    gotoxy (1,17);
    writeln ('(c) 1993 Anders Carlsson och DatorSektionen, Wenstrmska Skolan, Vsters');
    gotoxy (1,24);
    writeln ('TRYCK EN TANGENT FR ATT BRJA DAGEN P TRAVBANAN! (Escape avslutar spelet)');
    tang;
  end;

procedure odds;
  begin
    winit (1,11,30,23,1,15);
    randomize;
    gotoxy (1,2);
    writeln ('  -"Och nu fljer lopp nr ',lp,'"');
    gotoxy (1,4);
    writeln ('  Nr  Namn              Odds');
    for i:=1 to 8 do begin
      v[i]:=0;
      hodds[i]:=random(700)/100+1;
      repeat
        j:=random(56)+1;
        hnamn[i]:=kuse[j];
      until knum[j]=false;
      knum[j]:=true;
      writeln (i:4,'  ',hnamn[i],hodds[i]:6:2);
    end;
  end;

procedure kapital;
  begin
    gotoxy (1,2);
    clreol;
    writeln ('  Du har ',kr,' kr.');
  end;

procedure satsa;
  begin
    winit (31,11,80,23,4,14);
    for i:=0 to 8 do hnum[i]:=false;
    for i:=1 to 3 do begin
      kapital;
      h:=0;
      repeat
        co:=0;
        gotoxy (1,3*i+1); clreol;
        write ('  Vilken hst vill du satsa p (0=Klar)? ');
        cz:=readkey; write (cz);
        if cz=#13 then cz:='0';
        if (cz>'/') and (cz<'9') then begin
          j:=ord(cz)-48;
          if hnum[j]<>false then co:=1;
        end else co:=2;
      until co=0;
      if j=0 then exit;
      cz:=#0;
      gotoxy (1,3*i+2); clreol;
      write ('  Hur mycket (Max ',kr div 2,')? ');
      xpo:=wherex;
      str(kr div 2,sg);
      max:=length(sg); sg:='';
      while (wherex<=max+xpo-1) and (cz<>#13) do begin
        cz:=readkey;
        if (cz>'/') and (cz<':') then begin
          write (cz);
          sg:=sg+cz;
        end;
        if (cz=#8) and (wherex>xpo) then begin
          write (#8,#255,#8);
          sg:=copy(sg,1,length(sg)-1);
        end;
      end;
      val(sg,h,co);
      if (h>(kr div 2)) or (sg='') then begin
        writeln ('  Det blir ',kr div 2,'!');
        h:=(kr div 2);
      end;
      kr:=kr-h;
      v[j]:=v[j]+h*hodds[j];
      hnum[j]:=true;
    end;
    kapital;
  end;

procedure lopp;
  begin
    goal:='';
    winit (1,1,80,10,0,15);
    gotoxy (1,2);
    for i:=1 to 8 do begin
      write (i,'');
      for j:=1 to 75 do write ('');
      write ('');
      x[i]:=3;
    end;
    Curs(true);
    repeat
      for i:=1 to 8 do begin
        randomize;
        ox[i]:=x[i];
        x[i]:=x[i]+trunc(2/hodds[i])+trunc(i/8*random);
        if random>trunc(1/hodds[i]) then x[i]:=x[i]+2;
        if random<0.25 then x[i]:=ox[i];
        gotoxy (ox[i],i+1);
        write ('');
        gotoxy (x[i],i+1);
        write (chr(244));
        if x[i]>78 then goal:=goal+chr(i+48);
        delay (40);
      end;
    until goal<>'';
    Curs(false);
  end;

procedure hastvi(cp:string; xp:byte);
  begin
    val(cp,j,co);
    gotoxy (xp,wherey);
    writeln (j,', ',hnamn[j]);
  end;


procedure malfoto;
  begin
    if length(goal)=1 then begin
      write('  Vinnande hst blev nr');
      hastvi(goal,25);
      end else begin
      write('  Vinnande hstar blev nr');
      for i:=1 to length(goal)-1 do hastvi(goal[i],27);
      gotoxy (23,wherey);
      write('och');
      hastvi (goal[i+1],27);
    end;
  end;

procedure vinst;
  begin
    winit (31,11,80,23,5,15);
    gotoxy (1,2);
    malfoto;
    gotoxy (1,length(goal)+3);
    h:=0;
    for i:=1 to length(goal) do begin
     val(goal[i],j,co);
     h:=h+trunc(v[j]);
    end;
    if h>0 then begin
      writeln ('  Din vinst blev ',h,'.');
      inc(vi);
    end else writeln ('  Du satsade tyvrr p fel hst!');
    kr:=kr+h;
    winit (10,24,70,25,0,15);
    writeln ('TRYCK EN TANGENT FR NSTA LOPP ELLER ESCAPE FR AVSLUTNING');
    tang;
  end;

procedure avslut;
  begin
    winit (1,1,80,25,0,15);
    gotoxy (1,2);
    write ('Du har nu fullfljt alla sju loppen.');
    writeln (' Du prickade in vinnaren i ',vi,' lopp.');
    case vi of
    5: begin
         writeln ('Det innebr att du fr en bonus p 500 kr.');
         kr:=kr+500;
       end;
    6: begin
         writeln ('Det innebr att du fr en bonus p 750 kr.');
         kr:=kr+750;
       end;
    7: begin
         writeln ('Det innebr att du fr en bonus p 1000 kr.');
         kr:=kr+1000;
       end else writeln ('Synd, du missade bonusen!');
    end;
    gotoxy (1,6);
    write ('Ditt slutliga kapital blev ',kr,' kr. ');
    if kr>1000 then writeln ('Du lmnar Solvalla som en segrare!')
      else writeln ('Bttre lycka nsta gng!');
  end;

begin
  read_horse;
  valk;
  repeat
    kr:=1000;
    vi:=0;
    lp:=1;
    while (lp<8) and (kr>2) do begin
      odds;
      satsa;
      lopp;
      vinst;
      inc(lp);
    end;
    avslut;
    gotoxy (10,24);
    writeln ('TRYCK EN TANGENT FR EN NY OMGNG ELLER ESCAPE FR AVSLUTNING');
    tang;
    for i:=1 to 56 do knum[i]:=false;
  until lp=9;
end.
